/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the Integrations type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Integrations{}

// Integrations struct for Integrations
type Integrations struct {
	AgentHandoff *bool `json:"agent_handoff,omitempty"`
	OptOut *bool `json:"opt_out,omitempty"`
	MainAction *bool `json:"main_action,omitempty"`
	Investment *bool `json:"investment,omitempty"`
	Labels []Tag `json:"labels,omitempty"`
	Segments []Tag `json:"segments,omitempty"`
}

// NewIntegrations instantiates a new Integrations object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewIntegrations() *Integrations {
	this := Integrations{}
	return &this
}

// NewIntegrationsWithDefaults instantiates a new Integrations object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewIntegrationsWithDefaults() *Integrations {
	this := Integrations{}
	return &this
}

// GetAgentHandoff returns the AgentHandoff field value if set, zero value otherwise.
func (o *Integrations) GetAgentHandoff() bool {
	if o == nil || IsNil(o.AgentHandoff) {
		var ret bool
		return ret
	}
	return *o.AgentHandoff
}

// GetAgentHandoffOk returns a tuple with the AgentHandoff field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Integrations) GetAgentHandoffOk() (*bool, bool) {
	if o == nil || IsNil(o.AgentHandoff) {
		return nil, false
	}
	return o.AgentHandoff, true
}

// HasAgentHandoff returns a boolean if a field has been set.
func (o *Integrations) HasAgentHandoff() bool {
	if o != nil && !IsNil(o.AgentHandoff) {
		return true
	}

	return false
}

// SetAgentHandoff gets a reference to the given bool and assigns it to the AgentHandoff field.
func (o *Integrations) SetAgentHandoff(v bool) {
	o.AgentHandoff = &v
}

// GetOptOut returns the OptOut field value if set, zero value otherwise.
func (o *Integrations) GetOptOut() bool {
	if o == nil || IsNil(o.OptOut) {
		var ret bool
		return ret
	}
	return *o.OptOut
}

// GetOptOutOk returns a tuple with the OptOut field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Integrations) GetOptOutOk() (*bool, bool) {
	if o == nil || IsNil(o.OptOut) {
		return nil, false
	}
	return o.OptOut, true
}

// HasOptOut returns a boolean if a field has been set.
func (o *Integrations) HasOptOut() bool {
	if o != nil && !IsNil(o.OptOut) {
		return true
	}

	return false
}

// SetOptOut gets a reference to the given bool and assigns it to the OptOut field.
func (o *Integrations) SetOptOut(v bool) {
	o.OptOut = &v
}

// GetMainAction returns the MainAction field value if set, zero value otherwise.
func (o *Integrations) GetMainAction() bool {
	if o == nil || IsNil(o.MainAction) {
		var ret bool
		return ret
	}
	return *o.MainAction
}

// GetMainActionOk returns a tuple with the MainAction field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Integrations) GetMainActionOk() (*bool, bool) {
	if o == nil || IsNil(o.MainAction) {
		return nil, false
	}
	return o.MainAction, true
}

// HasMainAction returns a boolean if a field has been set.
func (o *Integrations) HasMainAction() bool {
	if o != nil && !IsNil(o.MainAction) {
		return true
	}

	return false
}

// SetMainAction gets a reference to the given bool and assigns it to the MainAction field.
func (o *Integrations) SetMainAction(v bool) {
	o.MainAction = &v
}

// GetInvestment returns the Investment field value if set, zero value otherwise.
func (o *Integrations) GetInvestment() bool {
	if o == nil || IsNil(o.Investment) {
		var ret bool
		return ret
	}
	return *o.Investment
}

// GetInvestmentOk returns a tuple with the Investment field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Integrations) GetInvestmentOk() (*bool, bool) {
	if o == nil || IsNil(o.Investment) {
		return nil, false
	}
	return o.Investment, true
}

// HasInvestment returns a boolean if a field has been set.
func (o *Integrations) HasInvestment() bool {
	if o != nil && !IsNil(o.Investment) {
		return true
	}

	return false
}

// SetInvestment gets a reference to the given bool and assigns it to the Investment field.
func (o *Integrations) SetInvestment(v bool) {
	o.Investment = &v
}

// GetLabels returns the Labels field value if set, zero value otherwise.
func (o *Integrations) GetLabels() []Tag {
	if o == nil || IsNil(o.Labels) {
		var ret []Tag
		return ret
	}
	return o.Labels
}

// GetLabelsOk returns a tuple with the Labels field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Integrations) GetLabelsOk() ([]Tag, bool) {
	if o == nil || IsNil(o.Labels) {
		return nil, false
	}
	return o.Labels, true
}

// HasLabels returns a boolean if a field has been set.
func (o *Integrations) HasLabels() bool {
	if o != nil && !IsNil(o.Labels) {
		return true
	}

	return false
}

// SetLabels gets a reference to the given []Tag and assigns it to the Labels field.
func (o *Integrations) SetLabels(v []Tag) {
	o.Labels = v
}

// GetSegments returns the Segments field value if set, zero value otherwise.
func (o *Integrations) GetSegments() []Tag {
	if o == nil || IsNil(o.Segments) {
		var ret []Tag
		return ret
	}
	return o.Segments
}

// GetSegmentsOk returns a tuple with the Segments field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Integrations) GetSegmentsOk() ([]Tag, bool) {
	if o == nil || IsNil(o.Segments) {
		return nil, false
	}
	return o.Segments, true
}

// HasSegments returns a boolean if a field has been set.
func (o *Integrations) HasSegments() bool {
	if o != nil && !IsNil(o.Segments) {
		return true
	}

	return false
}

// SetSegments gets a reference to the given []Tag and assigns it to the Segments field.
func (o *Integrations) SetSegments(v []Tag) {
	o.Segments = v
}

func (o Integrations) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Integrations) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.AgentHandoff) {
		toSerialize["agent_handoff"] = o.AgentHandoff
	}
	if !IsNil(o.OptOut) {
		toSerialize["opt_out"] = o.OptOut
	}
	if !IsNil(o.MainAction) {
		toSerialize["main_action"] = o.MainAction
	}
	if !IsNil(o.Investment) {
		toSerialize["investment"] = o.Investment
	}
	if !IsNil(o.Labels) {
		toSerialize["labels"] = o.Labels
	}
	if !IsNil(o.Segments) {
		toSerialize["segments"] = o.Segments
	}
	return toSerialize, nil
}

type NullableIntegrations struct {
	value *Integrations
	isSet bool
}

func (v NullableIntegrations) Get() *Integrations {
	return v.value
}

func (v *NullableIntegrations) Set(val *Integrations) {
	v.value = val
	v.isSet = true
}

func (v NullableIntegrations) IsSet() bool {
	return v.isSet
}

func (v *NullableIntegrations) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableIntegrations(val *Integrations) *NullableIntegrations {
	return &NullableIntegrations{value: val, isSet: true}
}

func (v NullableIntegrations) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableIntegrations) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


